scala.reflect.macros.runtime

# MacroRuntimes

#### trait MacroRuntimes extends JavaReflectionRuntimes

Self Type
  Analyzer
Source
  MacroRuntimes.scala

Linear Supertypes
JavaReflectionRuntimes, AnyRef, Any
Known Subclasses
Analyzer, Duplicator, Duplicators, Erasure, Macros, SpecializationDuplicator, TreeCheckers, erasure, treeChecker
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. MacroRuntimes
2. JavaReflectionRuntimes
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### trait JavaReflectionResolvers extends AnyRef

   Definition Classes
     JavaReflectionRuntimes

2. #### type MacroRuntime = (tools.nsc.typechecker.Analyzer.MacroArgs) ⇒ Any

   Abstracts away resolution of macro runtimes.

3. #### class MacroRuntimeResolver extends tools.nsc.typechecker.Analyzer.JavaReflectionResolvers

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from MacroRuntimes to any2stringadd[MacroRuntimes] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (MacroRuntimes, B)

   Implicit information
     This member is added by an implicit conversion from MacroRuntimes to ArrowAssoc[MacroRuntimes] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

8. #### lazy val defaultMacroClassloader: ClassLoader

   Macro classloader that is used to resolve and run macro implementations.

   Macro classloader that is used to resolve and run macro implementations. Loads classes from from -cp (aka the library classpath). Is also capable of detecting REPL and reusing its classloader.

   When -Xmacro-jit is enabled, we sometimes fallback to on-the-fly compilation of macro implementations, which compiles implementations into a virtual directory (very much like REPL does) and then conjures a classloader mapped to that virtual directory.

9. #### def ensuring(cond: (MacroRuntimes) ⇒ Boolean, msg: ⇒ Any): MacroRuntimes

   Implicit information
     This member is added by an implicit conversion from MacroRuntimes to Ensuring[MacroRuntimes] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: (MacroRuntimes) ⇒ Boolean): MacroRuntimes

    Implicit information
      This member is added by an implicit conversion from MacroRuntimes to Ensuring[MacroRuntimes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean, msg: ⇒ Any): MacroRuntimes

    Implicit information
      This member is added by an implicit conversion from MacroRuntimes to Ensuring[MacroRuntimes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean): MacroRuntimes

    Implicit information
      This member is added by an implicit conversion from MacroRuntimes to Ensuring[MacroRuntimes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

15. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

16. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from MacroRuntimes to StringFormat[MacroRuntimes] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

17. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

18. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

19. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

20. #### def macroRuntime(expandee: tools.nsc.Global.Tree): tools.nsc.typechecker.Analyzer.MacroRuntime

    Produces a function that can be used to invoke macro implementation for a given macro definition: 1) Looks up macro implementation symbol in this universe.

    Produces a function that can be used to invoke macro implementation for a given macro definition: 1) Looks up macro implementation symbol in this universe. 2) Loads its enclosing class from the macro classloader. 3) Loads the companion of that enclosing class from the macro classloader. 4) Resolves macro implementation within the loaded companion.

    returns

      Requested runtime if macro implementation can be loaded successfully from either of the mirrors, `null` otherwise.

21. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

22. #### final def notify(): Unit

    Definition Classes
      AnyRef

23. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

24. #### def standardMacroRuntime(expandee: tools.nsc.Global.Tree): tools.nsc.typechecker.Analyzer.MacroRuntime

25. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

26. #### def toString(): String

    Definition Classes
      AnyRef → Any

27. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

28. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

29. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

30. #### def →[B](y: B): (MacroRuntimes, B)

    Implicit information
      This member is added by an implicit conversion from MacroRuntimes to ArrowAssoc[MacroRuntimes] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from JavaReflectionRuntimes

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from MacroRuntimes to any2stringadd[MacroRuntimes]

### Inherited by implicit conversion StringFormat from MacroRuntimes to StringFormat[MacroRuntimes]

### Inherited by implicit conversion Ensuring from MacroRuntimes to Ensuring[MacroRuntimes]

### Inherited by implicit conversion ArrowAssoc from MacroRuntimes to ArrowAssoc[MacroRuntimes]

### Ungrouped